import { Common, Query, ReplicatorBase } from './couchbase-plugin.common';
export { Query, QueryMeta, QueryArrayOperator, QueryComparisonOperator, QueryLogicalOperator, QueryOrderItem, QueryWhereItem } from './couchbase-plugin.common';
export declare class Couchbase extends Common {
    constructor(databaseName: string);
    createDocument(data: Object, documentId?: string): any;
    private fromISO8601UTC(date);
    private serializeObject(item, object, key);
    private serializeArray(item, array);
    private serialize(item, doc, key);
    getDocument(documentId: string): any;
    private deserialize(data);
    updateDocument(documentId: string, data: any): void;
    deleteDocument(documentId: string): any;
    destroyDatabase(): any;
    createPullReplication(remoteUrl: string): Replicator;
    createPushReplication(remoteUrl: string): Replicator;
    addDatabaseChangeListener(callback: any): void;
    private setComparision(item);
    query(query?: Query): any[];
}
export declare class Replicator extends ReplicatorBase {
    constructor(replicator: any);
    start(): void;
    stop(): void;
    isRunning(): boolean;
    setContinuous(isContinuous: boolean): void;
    setUserNameAndPassword(username: string, password: string): void;
    setSessionIdAndCookieName(sessionId: string, cookieName: string): void;
    setSessionId(sessionId: string): void;
}
